package com.perforce.hive;

import static org.junit.Assert.*;

import java.io.File;

import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;

import com.perforce.hive.connection.ConnectionConfig;

import spark.Spark;

public class CoreTest {

	@BeforeClass
	public static void beforeClass() {
		try {
			UnitServer server = new UnitServer("p4_root");
			server.clean();
			server.extract("depots.tar.gz");
			server.restore("checkpoint");
			server.upgrade();
			
			// load Connection configurations and set rsh port
			ConnectionConfig.get().load("test-core");
			String rsh = server.getRshPort();
			String key = "com.perforce.hive.p4port";
			ConnectionConfig.get().set(key, rsh);
			
			Spark.port(ConnectionConfig.get().getPort());
			Spark.staticFileLocation("/public");

			File pluginArchiveFile = new File("plugins/LocalPlugin-0.1.0.zip");
			PluginArtifactFactory.loadPlugins(pluginArchiveFile);
			Main.start();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@AfterClass
	public static void afterClass() {
		Spark.stop();
	}

	@Test
	public void testBrowse() {
		UnitResponse res = UnitSpark.request("GET", "/browse");
		assertEquals(200, res.status);
		
		String page = res.body;
		assertTrue(page.contains("Depot"));

	}
}
